create or replace TRIGGER TRILHAUDIT_RESPOSINSPEC
BEFORE INSERT OR UPDATE OR DELETE
ON RESPOSINSPEC FOR EACH ROW
DECLARE
   V_NRSEQTRILHA  NUMBER(10);
   V_NMPRODUTO    VARCHAR2(50);
   V_TIPOPROC     VARCHAR2(50);
   V_NMINSPECAO   VARCHAR2(100);
   V_ITEMALTERADO VARCHAR2(300);
   V_CDOPERADOR   VARCHAR2(12);
   V_CLIENT_INFO  VARCHAR2(64);
   V_CDARVINSPEC  VARCHAR2(50);
   V_MAXNVINSPEC  NUMBER;
   V_NMANALISE    VARCHAR2(200);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_ITEMALTERADO := '';
   V_CDARVINSPEC  := '';

   --NMUSUARIO(V_NMOPERADOR);
   --DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   --V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,45,12);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   V_CDOPERADOR := V_DSREMOTEOPER;

   IF INSERTING THEN
      IF :NEW.CDPRODUTO IS NOT NULL THEN
         SELECT (NVL(MAX(NRSEQTRILHA),0)  + 1) AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;


         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Insero de Resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;


         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :NEW.CDPRODUTO, :NEW.IDRESPPROC, 'I', SYSDATE, NULL, 'Insero da Resposta ' || :NEW.NMRESPINSPEC, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
   ELSIF DELETING THEN
      IF (:OLD.CDPRODUTO IS NOT NULL) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :OLD.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :OLD.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Excluso ' || :OLD.NMRESPINSPEC || '  ' || :OLD.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'E', SYSDATE, NULL, 'Excluso de Resposta', V_CDOPERADOR, 'Excluso da Resposta ' || :OLD.NMRESPINSPEC);
      END IF;
   ELSIF UPDATING THEN
      IF ((:NEW.CDPRODUTO <> :OLD.CDPRODUTO)  AND (:OLD.CDPRODUTO IS NOT NULL)) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         V_ITEMALTERADO :=  'Produto da Resposta ' || :NEW.NMRESPINSPEC;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.CDPRODUTO, :NEW.CDPRODUTO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.IDSTATUSRESP <> :OLD.IDSTATUSRESP) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Status da Resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, DECODE(:OLD.IDSTATUSRESP, 'I', 'Inativo', 'Ativo'), DECODE(:NEW.IDSTATUSRESP, 'I', 'Inativo', 'Ativo'), V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.NMRESPINSPEC <> :OLD.NMRESPINSPEC) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Nome da Resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;


            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.NMRESPINSPEC, :NEW.NMRESPINSPEC, V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.IDFAIXRESINS <> :OLD.IDFAIXRESINS) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Tipo de Faixa da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, DECODE(:OLD.IDFAIXRESINS, '>', 'Maior que', '<', 'Menor que', 'Entre'),
                  DECODE(:NEW.IDFAIXRESINS, '>', 'Maior que', '<', 'Menor que', 'Entre'), V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.VRINIFAIXRES <> :OLD.VRINIFAIXRES) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Faixa Inicial da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.VRINIFAIXRES,
                :NEW.VRINIFAIXRES, V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.VRFINFAIXRES <> :OLD.VRFINFAIXRES) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Faixa Final da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.VRFINFAIXRES,
                :NEW.VRFINFAIXRES, V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.DTINIFAIXRES <> :OLD.DTINIFAIXRES) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Data Inicial da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.DTINIFAIXRES,
                :NEW.DTINIFAIXRES, V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.DTFINFAIXRES <> :OLD.DTFINFAIXRES) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Data Final da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.DTFINFAIXRES,
                :NEW.DTFINFAIXRES, V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;

      IF (:NEW.SGUNIDADE <> :OLD.SGUNIDADE) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Unidade ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, :OLD.SGUNIDADE,
                :NEW.SGUNIDADE, V_CDOPERADOR, V_ITEMALTERADO);
        END IF;
      END IF;

      IF (:NEW.VRPONTRESINS <> :OLD.VRPONTRESINS) THEN
         IF (:OLD.CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
                 INTO V_NRSEQTRILHA
                 FROM TRILHAUDIT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMINSPECAO
                 FROM INSPECAO
                WHERE CDINSPECAO = :NEW.CDINSPECAO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMINSPECAO := NULL;
            END;

            BEGIN
               SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
                 INTO V_CDARVINSPEC, V_MAXNVINSPEC
                 FROM INSPECAO
                WHERE IDORIGINSPEC IN 'ANA'
                  AND CDINSPECAO = :NEW.CDINSPECAO
                GROUP BY CDARVINSPEC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_CDARVINSPEC := NULL;
               V_MAXNVINSPEC := NULL;
            END;

            BEGIN
               SELECT NMINSPECAO
                 INTO V_NMANALISE
                 FROM INSPECAO
                WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
                  AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
               V_NMANALISE := NULL;
            END;

            V_ITEMALTERADO :=  'Pontuao da resposta ' || :NEW.NMRESPINSPEC || '  ' || :NEW.CDRESPINSPEC || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

            INSERT INTO TRILHAUDIT
               (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
               (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDRESPPROC, 'A', SYSDATE, (CASE WHEN :OLD.VRPONTRESINS = '0' THEN 'Correto'
                                                                                    WHEN :OLD.VRPONTRESINS = '1' THEN 'Aceitvel'
                                                                                    WHEN :OLD.VRPONTRESINS = '2' THEN 'Errado' END),
                                                                              (CASE WHEN :NEW.VRPONTRESINS = '0' THEN 'Correto'
                                                                                    WHEN :NEW.VRPONTRESINS = '1' THEN 'Aceitvel'
                                                                                    WHEN :NEW.VRPONTRESINS = '2' THEN 'Errado' END),
                V_CDOPERADOR, V_ITEMALTERADO);
         END IF;
      END IF;
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('TRILHAUDIT_RESPOSINSPEC','6.05.xxx'); END;
/
