/* Sistemas Integrados TEKNISA
  Fechamento do Dia - Gerao CFC (RNF) para outros pases

Nome: 0001_SDX_TABECFC_EXTERIOR.SQL

Descrio:
Criao das tabelas especficas para gerao da CFC (RNF) para outros pases

@C:\Web_503\Xdb\Src\Cli\SDX\SQL\Chi\0001_SDX_TABECFC_EXTERIOR.SQL

Criao:
02/09/2008 - Fabrcio Marcelo da Silva
*/

CREATE TABLE USR_HEAD_TRAIL_CFC
(
    SOCIEDAD              VARCHAR2(10)        null,
    CENTCUST              VARCHAR2(12)        null,
    NRCFC                 VARCHAR2(06)        null,
    DTCFC                 DATE                null,
    HRCFC                 VARCHAR2(05)        null,
    NOMEA                 VARCHAR2(16)        null,
    QTDDT                 VARCHAR2(06)        null,
    DTIMPORTACAO          DATE                null
)
/

CREATE TABLE USR_CORPO_CFC
(
    SOCIEDAD              VARCHAR2(10)        null,
    CENTCUST              VARCHAR2(12)        null,
    NRCFC                 VARCHAR2(06)        null,
    DTCFC                 DATE                null,
    CDRUT                 VARCHAR2(14)        null,
    CDSER                 VARCHAR2(03)        null,
    NRNOT                 VARCHAR2(08)        null,
    VLCFC                 FLOAT               null,
    DTEMI                 DATE                null,
    DTVEN                 DATE                null,
    VLRIVA                FLOAT               null,
    VLROUIMP              FLOAT               null,
    DTIMPORTACAO          DATE                null
)
/

CREATE TABLE USR_ITEM_CFC
(
    SOCIEDAD              VARCHAR2(10)        null,
    CENTCUST              VARCHAR2(12)        null,
    NRCFC                 VARCHAR2(06)        null,
    DTCFC                 DATE                null,
    CDRUT                 VARCHAR2(14)        null,
    CDSER                 VARCHAR2(03)        null,
    NRNOT                 VARCHAR2(08)        null,
    ITEMNF                VARCHAR2(03)        null,
    CODPROD               VARCHAR2(20)        null,
    VLRITEMNF             FLOAT               null,
    ALIQU                 FLOAT               null,
    VLRIVA                FLOAT               null,
    VLROUIMP              FLOAT               null,
    QTDE                  FLOAT               null,
    VLUNIT                FLOAT               null,
    DTIMPORTACAO          DATE                null
)
/

ALTER TABLE USR_HEAD_TRAIL_CFC ADD CONSTRAINT  PK_HEAD_CFC PRIMARY KEY (SOCIEDAD, CENTCUST, NRCFC, DTCFC)
/

ALTER TABLE USR_CORPO_CFC ADD CONSTRAINT PK_CORPO_CFC PRIMARY KEY (SOCIEDAD, CENTCUST, NRCFC, DTCFC, CDRUT, CDSER, NRNOT)
/

ALTER TABLE USR_ITEM_CFC ADD CONSTRAINT  PK_ITEM_CFC PRIMARY KEY (SOCIEDAD, CENTCUST, NRCFC, DTCFC, CDRUT, CDSER, NRNOT, ITEMNF)
/

ALTER TABLE USR_CORPO_CFC
   ADD CONSTRAINT FKHEAD FOREIGN KEY (SOCIEDAD, CENTCUST, NRCFC, DTCFC)
      REFERENCES USR_HEAD_TRAIL_CFC (SOCIEDAD, CENTCUST, NRCFC, DTCFC)
/

ALTER TABLE USR_ITEM_CFC
   ADD CONSTRAINT FKCORPO FOREIGN KEY (SOCIEDAD, CENTCUST, NRCFC, DTCFC, CDRUT, CDSER, NRNOT)
      REFERENCES USR_CORPO_CFC (SOCIEDAD, CENTCUST, NRCFC, DTCFC, CDRUT, CDSER, NRNOT)
/

CREATE INDEX HEAD_FK ON USR_HEAD_TRAIL_CFC (DTCFC ASC)
/

CREATE INDEX HEAD_02 ON USR_HEAD_TRAIL_CFC (DTIMPORTACAO ASC)
/

ALTER TABLE USR_CORPO_CFC MODIFY  NRNOT   VARCHAR2(10)
/

ALTER TABLE USR_ITEM_CFC MODIFY  NRNOT   VARCHAR2(10)
/
