IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_AGENTETERCECLI' 
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP TRIGGER LOG_GER_AGENTETERCECLI
GO

CREATE TRIGGER LOG_GER_AGENTETERCECLI
ON AGENTETERCECLI
FOR UPDATE, INSERT, DELETE
AS
BEGIN
   DECLARE @V_USUARIO      VARCHAR(40);
   DECLARE @V_TIPO         VARCHAR(01);
   DECLARE @V_TPMOVI       VARCHAR(01);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_DESC         VARCHAR(700);
   DECLARE @V_CDFILLOGOPER VARCHAR(04);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DTOPER       DATETIME;

   /* ****INCIO DAS VARIVEIS DO C_CURSOR***** */
   DECLARE @V_OLD_CDFILIAL     VARCHAR(04);
   DECLARE @V_OLD_CDCLIENTE    VARCHAR(21);
   DECLARE @V_OLD_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_OLD_CDLOCALESTOQ VARCHAR(06)
  
   DECLARE @V_NEW_CDFILIAL     VARCHAR(04);
   DECLARE @V_NEW_CDCLIENTE    VARCHAR(21);
   DECLARE @V_NEW_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_NEW_CDLOCALESTOQ VARCHAR(06)
   /* ****FINAL DAS VARIVEIS DO C_CURSOR***** */

   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_CDFILLOGOPER = '';

   DECLARE C_CURSOR CURSOR FOR
      SELECT 
         'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         DELETED.CDFILIAL,
         DELETED.CDCLIENTE,
         DELETED.CDALMOXARIFE,
         DELETED.CDLOCALESTOQ
      FROM
         DELETED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.CDCLIENTE,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         DELETED.CDFILIAL,
         DELETED.CDCLIENTE,
         DELETED.CDALMOXARIFE,
         DELETED.CDLOCALESTOQ
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL  AND
         INSERTED.CDCLIENTE = DELETED.CDCLIENTE

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.CDCLIENTE,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT 
                 COUNT(*) 
              FROM 
                 DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_TIPO, 
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDCLIENTE,
                                 @V_NEW_CDALMOXARIFE,
                                 @V_NEW_CDLOCALESTOQ,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDCLIENTE,
                                 @V_OLD_CDALMOXARIFE,
                                 @V_OLD_CDLOCALESTOQ;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      /* DELETE */
      IF @V_TIPO = 'D' BEGIN
         SET @V_TPMOVI       = '3';
         SET @V_ITPESQ       = @V_OLD_CDFILIAL + @V_OLD_CDCLIENTE;
         SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
         
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_OLD_CDFILIAL;
         END;

         IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Cliente=' + @V_OLD_CDCLIENTE;
         END;

         IF @V_OLD_CDALMOXARIFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Almoxarifado=' + @V_OLD_CDALMOXARIFE;
         END;

         IF @V_OLD_CDLOCALESTOQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Localizao=' + @V_OLD_CDLOCALESTOQ;
         END;
      END
      ELSE BEGIN
         /* UPDATE */
         IF @V_TIPO = 'U' BEGIN
            IF (ISNULL(@V_OLD_CDFILIAL, '!')     <> ISNULL(@V_NEW_CDFILIAL, '!'))     OR
               (ISNULL(@V_OLD_CDCLIENTE, '!')    <> ISNULL(@V_NEW_CDCLIENTE, '!'))    OR
               (ISNULL(@V_OLD_CDALMOXARIFE, '!') <> ISNULL(@V_NEW_CDALMOXARIFE, '!')) OR
               (ISNULL(@V_OLD_CDFILIAL, '!')     <> ISNULL(@V_NEW_CDLOCALESTOQ, '!'))  
            BEGIN
               SET @V_TPMOVI       = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL + @V_OLD_CDCLIENTE;
               SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN
            /* INSERT */
            SET @V_TPMOVI        = '1';
            SET @V_ITPESQ        = @V_NEW_CDFILIAL + @V_NEW_CDCLIENTE;
            SET @V_CDFILLOGOPER  = @V_NEW_CDFILIAL;
         END;

         IF ISNULL(@V_NEW_CDFILIAL, '!') <> ISNULL(@V_OLD_CDFILIAL, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_CDFILIAL;
         END;

         IF ISNULL(@V_NEW_CDCLIENTE, '!') <> ISNULL(@V_OLD_CDCLIENTE, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Cliente=' + @V_NEW_CDCLIENTE;
         END;

         IF ISNULL(@V_NEW_CDALMOXARIFE, '!') <> ISNULL(@V_OLD_CDALMOXARIFE, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Almoxarifado=' + @V_NEW_CDALMOXARIFE;
         END;

         IF ISNULL(@V_NEW_CDLOCALESTOQ, '!') <> ISNULL(@V_OLD_CDLOCALESTOQ, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Localizao=' + @V_NEW_CDLOCALESTOQ;
         END;
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_USUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   CDFILLOGOPER,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('AGENTETERCECLI',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,700),
                   @V_CDFILLOGOPER,
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_TIPO, 
                                    @V_NEW_CDFILIAL,
                                    @V_NEW_CDCLIENTE,
                                    @V_NEW_CDALMOXARIFE,
                                    @V_NEW_CDLOCALESTOQ,
                                    @V_OLD_CDFILIAL,
                                    @V_OLD_CDCLIENTE,
                                    @V_OLD_CDALMOXARIFE,
                                    @V_OLD_CDLOCALESTOQ;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_AGENTETERCECLI','5.85.xxx';
GO
