<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class PtoPeriodoapuracao extends \Doctrine\ORM\EntityRepository {
    
    public function getPeriodoIntervalo($nrorg, $periodo){
        $query = 'SELECT TO_CHAR(PA.DTINICIALAPURACAO, \'DD/MM/YYYY\') DTINICIALAPURACAO, 
                         TO_CHAR(PA.DTFINALAPURACAO, \'DD/MM/YYYY\') DTFINALAPURACAO, 
                         (NVL( SUBSTR(PO.HRTEMPODESCANSODIARIO, 1, 2) + ( SUBSTR(PO.HRTEMPODESCANSODIARIO, 4, 2) / 60 ), 11)) HRTEMPODESCANSODIARIO
                    FROM PTO_PERIODOAPURACAO PA
                    JOIN GPE_PARAMORG PO ON PO.NRORG = PA.NRORG
                   WHERE PA.NRORG             = :P_NRORG
                     AND PA.NRPERIODOAPURACAO = :P_PERIODO';
        $params = array('P_NRORG'   => $nrorg,
                        'P_PERIODO' => $periodo);
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($query, $params);
        return $result;
    }

    public function getPeriodoApuracao($nrorg, $dtultdiacompetenc, $idperiodoapuracao, $nrtipoperiodoapuracao, $nrtipovinculom)
    {
        $ptoPeriodoApuracao = 'Teknisa\Model\Gestaopessoas\Entities\PtoPeriodoapuracao';
        $ptoTipoperiodoApuracao = 'Teknisa\Model\Gestaopessoas\Entities\PtoTipoperiodoapuracao';

$sql = <<<SQL
    SELECT pa
      FROM $ptoPeriodoApuracao pa 
      JOIN $ptoTipoperiodoApuracao tp WITH tp.nrorg = pa.nrorg
                                       AND tp.nrtipoperiodoapuracao = pa.nrtipoperiodoapuracao
                                       AND tp.idativo = 'S'
     WHERE pa.nrorg = :p_nrorg
       AND pa.dtfinalapuracao <= :p_dtultdiacompetenc
       AND (pa.idperiodoapuracao = :p_idperiodoapuracao OR :p_idperiodoapuracao is null)
       AND (pa.nrtipoperiodoapuracao = :p_nrtipoperiodoapuracao OR :p_nrtipoperiodoapuracao is null)
       AND (tp.nrtipovinculom = :p_nrtipovinculom OR :p_nrtipovinculom is null)
     ORDER BY pa.dtfinalapuracao DESC
SQL;
            $params = array(
                'p_nrorg' => $nrorg,
                'p_dtultdiacompetenc' => $dtultdiacompetenc,
                'p_nrtipovinculom' => $nrtipovinculom,
                'p_idperiodoapuracao' => $idperiodoapuracao,
                'p_nrtipoperiodoapuracao' => $nrtipoperiodoapuracao,
            );
            
            $result = $this->getEntityManager()->createQuery($sql)->execute($params);
            return $result;
    }
}
